;PCM2BRZ1.ASM
;
; PCM DATA CONVERTER for BREEZE
;on S-OS "SWORD" or "SWORD" compatible  OS
;V1.00
;
;
;from
; 4bit AD-PCM DATA(from 'X68K') ,
; 16bit PCM DATA(linear signed,big-endian) ,
; 16bit PCM DATA(linear signed,small-endian) ,
; 8bit PCM DATA(linear signed) ,
; 8bit PCM DATA(linear unsigned) ,
; 8bit PCM DATA(FM 'TOWNS' '.SND')
;to 8bit PCM DATA(BREEZE)
;
;
; S-OS SYSTEM CALL
;
#HOT    EQU     $1FFA
#VER    EQU     $1FF7
#PRINT  EQU     $1FF4
#PRNTS  EQU     $1FF1
#LTNL   EQU     $1FEE
#MSX    EQU     $1FE5
#MPRNT  EQU     $1FE2
#GETL   EQU     $1FD3
#GETKY  EQU     $1FD0
#BRKEY  EQU     $1FCD
#INKEY  EQU     $1FCA
#PRTHL  EQU     $1FBE
#WOPEN  EQU     $1FAF
#WRD    EQU     $1FAC
#RDD    EQU     $1FA6
#FILE   EQU     $1FA3
#FPRNT  EQU     $1F9D
#DIR    EQU     $2006
#ROPEN  EQU     $2009
#CSR    EQU     $2018
#LOC    EQU     $201E
;
; S-OS SYSTEM WORK
;
#KBFAD  EQU     $1F76
#SIZE   EQU     $1F72
#DTADR  EQU     $1F70
#EXADR  EQU     $1F6E
#MEMAX  EQU     $1F6A
#DSK    EQU     $1F5D
;
;
ENTRY   EQU     $3000
;MEMTOP =CODE_END
;
HDRSIZE EQU     32      ;SDAC (check! SDAC REFERENCE out)
HDR_NAM EQU     0
HDR_SIZ EQU     8
HDR_FRQ EQU     12
HDR_RSV EQU     16
;
DATATOP EQU     $3000           ;for FILE
MAXSPEC EQU     6               ;5+1
MAXSMN  EQU     16
ATR_BIN EQU     1
ATR_ASC EQU     4
;
;
        ORG     ENTRY
        OFFSET  $C000-ENTRY
;
;
START:
;       LD      (BFSTACK),SP
;       LD      SP,USRSTK
CREDIT:
        CALL    #MPRNT
        DB      "********************",$0D
        DB      " PCM DATA CONVERTER ",$0D
        DB      "   FROM SOME TYPES  ",$0D
        DB      "     TO BREESE      ",$0D
        DB      "               V1.00",$0D
        DB      "********************",$0D
        DB      "    #MEMAX:",$00
        LD      HL,(#MEMAX)
        CALL    #PRTHL
        CALL    #LTNL
;
        LD      HL,(#MEMAX)
        LD      DE,CODE_END
        OR      A
        SBC     HL,DE
        LD      (MEMSIZE),HL
;
        LD      HL,MEMTOP
        LD      (MEMADR1),HL
;
        LD      A,13
        LD      (LENGTH_PRIMARY),A
        CALL    #VER
        BIT     7,L
        JR      Z,MLOP1
;       L-OS!
        LD      A,8
        LD      (LENGTH_PRIMARY),A
MLOP1:
        CALL    CONV
        JR      NZ,MLOP1
QUIT:
;       LD      SP,(BFSTACK)
        XOR     A
        RET
;
; WORK
;
LENGTH_PRIMARY: DB      13      ;13:S-OS 8:L-OS
;
MEMSIZE:DW      0
MEMADR1:DW      0       ;=MEMTOP
MEMADR2:DW      0       ;SHIFTED to LOWER ADR
;
D_SIZ:  DW      0
D_SIZ2: DW      0
D_SIZR: DW      0               ;REMAINING
D_FREQ: DW      15600
D_FREQ2:DW      15600
D_SNAME:DS      8
        DB      $00
;
D_MGETA:DW      3
D_CENT: DW      0
D_OVER: DW      0
D_MODE: DB      0
D_MODE3:DB      0
D_ERR:  DB      0
D_ILCNT:DW      0
D_EVEN: DB      0
D_SMN:  DB      0
D_SMP:  DB      0
;
FSIZE1: DW      0       ;LOAD FILE
FSIZE2: DW      0       ;SAVE FILE
;
BFSTACK:DW      0
BFCSR1: DW      0
BFATR:  DB      0
BFDE1:  DW      0
BFDE2:  DW      0
BFFN1:  DS      32
BFFN2:  DS      32
SMTBL:  DS      MAXSMN
;
;[EOF]
