;PCM2BRZ3.ASM
;
;
; CONVERT
;
CONV1:
        LD      HL,0
        LD      (D_OVER),HL
        LD      (XX),HL         ;ADPCM to PCM
        LD      H,$80           ;HL=32768
        LD      (YY),HL
        LD      DE,(D_MGETA)    ;OFFSET(16b to 8b)
        CALL    DIV16
        CALL    NEGHL
        LD      A,128
        CALL    HLADDA
        LD      (D_CENT),HL
        LD      HL,(D_FREQ)     ;for INTERACE
        SRL     H
        RR      L
        LD      (D_ILCNT),HL
        XOR     A
        LD      (D_EVEN),A      ;'EVEN'
        LD      (D_SMP),A       ;for SMOOTHING
        LD      HL,(D_FREQ)
        DEC     HL
        LD      DE,(D_FREQ2)
        CALL    DIV16
        LD      A,L
        INC     A               ;D_SMN>0
        CP      MAXSMN
        JR      C,CONV105       ;D_SMN<MAXSMN?
        LD      A,MAXSMN-1
CONV105:
        LD      (D_SMN),A
        CALL    CSMTBL
;
        LD      A,(D_MODE)
        CALL    SWITCH
;
        LD      HL,(MEMADR2)            ;SOURCE
        LD      DE,MEMTOP+HDRSIZE       ;DISTINATION
        CALL    GETSIZE
CONV11:
        EXX
        LD      HL,(D_ILCNT)
        LD      DE,(D_FREQ)
        LD      BC,(D_FREQ2)
        CALL    ILCHK
        LD      (D_ILCNT),HL
        JR      Z,CONV12
        EXX
CONV1SW1:                       ;SWITCHING BLOCK(12BYTES)
;       CONVERT
        CALL    CONV1L2         ;INCLUDING 'EXX'
        CALL    CONV1C2
        CALL    CONV1C1
;
        JR      NZ,CONV111      ;NOT CLIPPED OUT?
        LD      HL,(D_OVER)
        INC     HL
        LD      (D_OVER),HL
CONV111:
        LD      (CONVBF1),A     ;8BIT PCM
        LD      HL,D_MODE3
        BIT     0,(HL)
        JR      NZ,CONV112
;       SMOOTHING
        CALL    PUTSMTBL        ;
CONV112:
        EXX
CONV1SW2:                       ;3BYTES
;       SOURCE GO 1STEP
        CALL    GO1S2           ;SOURCE
;
        JR      Z,CONV19        ;SOURCE END?
        JR      CONV11
CONV12:
;       DESTINATION GO 1STEP
        LD      A,(CONVBF1)
        LD      HL,D_MODE3
        BIT     0,(HL)
        JR      NZ,CONV121
;       SMOOTHING
        CALL    GETSMTBL
CONV121:
        EXX
        LD      (DE),A          ;DESTINATION
        INC     DE
        OR      A
        EX      DE,HL
        SBC     HL,DE
        ADD     HL,DE
        EX      DE,HL
        JR      C,CONV122       ;NOT MEMORY OVER?
        LD      A,1
        LD      (D_ERR),A       ;MEMORY OVER
        JR      CONV19
CONV122:
        JP      CONV11
CONV19:
        LD      (D_SIZR),BC     ;REMAINING DATA SIZE
        EX      DE,HL
        LD      DE,MEMTOP+HDRSIZE
        OR      A
        SBC     HL,DE
        LD      (D_SIZ2),HL     ;PROCCESSED DATA SIZE
        RET
CONVBF1:
        DB      0

;
; CONVERT 16BIT to 8 BIT
;        (UNSIGNED)   (BREEZE)
; ENTRY HL:PCMDATA(0-65535)
; EXIT  A:PMDATA(0-255)
;       Z:CLIPPED
CONV1C1:
        LD      A,(D_MGETA+0)
        LD      DE,(D_CENT)
        CALL    CNVPWTOPH
        RET
;
; CONVERT 4BIT to 16BIT
;          (ADPCM)  (UNSIGNED)
; ENTRY A:ADPCM DATA
;       (XX):INDEX(0-48)
;       (YY):PCM DATA
; EXIT  HL,(YY):PCM DATA
;       (XX):INDEX(0-48)
CONV1C2:
        LD      BC,(XX)         ;B reg. is DMY
        CALL    CNVADTOPW
        CALL    XCLIP
        LD      DE,(YY)
        ADD     HL,DE
        LD      (YY),HL
        LD      A,C
        LD      (XX),A
        RET
;
; CONVERT 8BIT to 8 BIT
;        (SIGNED)   (UNSIGNED,BREEZE)
; ENTRY A:PCMDATA(-128..127)
; EXIT  A:PMDATA(0-255)
;       Z:CLIPPED
CONV1C3:
        ADD     A,$80
        LD      B,0             ;??
        INC     B               ;NZ NO CLIPPING
        RET
;
; CONVERT 8BIT to 8 BIT
;        (TOWNS)   (UNSIGNED,BREEZE)
; ENTRY A:PCMDATA(+/- 0..127)
; EXIT  A:PMDATA(1-255)
;       Z:CLIPPED
CONV1C4:
        BIT     7,A
        JP      Z,CONV1C41
        XOR     $7F
        INC     A
CONV1C41:
        ADD     A,$80
        LD      B,0             ;??
        INC     B               ;NZ NO CLIPPING
        RET
;
; DATA LOAD 16BIT DATA(BIG-ENDIAN,
;                       SIGNED)
; ENTRY HL:DATA ADR.
; EXIT  HL':DATA(UNSIGNED,0-65535)
CONV1L1:
        LD      A,128   ;+32768
        ADD     A,(HL)  ;BIG-ENDIAN
        PUSH    AF
        INC     HL
        LD      A,(HL)
        DEC     HL
        EXX
        LD      L,A
        POP     AF
        LD      H,A
        RET
;
; DATA LOAD 16BIT DATA(LITTLE-ENDIAN,
;                       SIGNED)
; ENTRY HL:DATA ADR.
; EXIT  HL':DATA(UNSIGNED,0-65535)
CONV1L15:
        LD      A,128
        ADD     A,(HL)  ;LITTLE-ENDIAN
        PUSH    AF
        INC     HL
        LD      A,(HL)
        DEC     HL
        EXX
        LD      H,A     ;LITTLE-ENDIAN!!
        POP     AF
        LD      L,A
        RET
;
; DATA LOAD 4BIT DATA(HIGH>>>LOW)
; ENTRY HL:DATA ADR.
;       (D_EVEN):EVEN|ODD
; EXIT  (D_EVEN):(D_EVEN)+1 MOD 2
;       A:4BIT DATA
CONV1L2:
        LD      A,(D_EVEN)
        XOR     1               ;BIT0 REVERSE
        LD      A,(HL)
        JR      NZ,CONV1L21:
        RRA
        RRA
        RRA
        RRA
CONV1L21:
        AND     1111B           ;MASK
        EXX
        RET
;
; DATA LOAD 8BIT DATA
; ENTRY HL:DATA ADR.
; EXIT  A:8BIT DATA
CONV1L3:
        LD      A,(HL)
        EXX
        RET
;
; GO 1 STEP (SOURCE=16BIT PCM)
; ENTRY HL:SOURCE ADR.
; EXIT  HL:SOURCE ADR.+2
;       Z:SOURCE END
GO1S1:
        INC     HL
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        RET
;
; GO 1 STEP (SOURCE=4BIT ADPCM)
; ENTRY HL:SOURCE ADR.
;       (D_EVEN):EVEN|ODD
; EXIT  HL:SOURCE ADR.|SOURCE ADR.+1
;       (D_EVEN):(D_EVEN)+1 MOD 2
;       Z:SOURCE END
GO1S2:
        LD      A,(D_EVEN)
        XOR     1
        LD      (D_EVEN),A
        RET     NZ      ;EVEN?
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        RET
;
; GO 1 STEP (SOURCE=8BIT PCM)
; ENTRY HL:SOURCE ADR.
; EXIT  HL:SOURCE ADR.+1
;       Z:SOURCE END
GO1S3:
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        RET
;
; GET STEP SIZE (16 BIT PCM)
; ENTRY (D_MODE)
; EXIT  BC:SIZE by STEP
GETSIZE:        ;2DATA/1BYTE
        LD      A,(D_MODE)
        OR      A
        JR      NZ,GETSIZE2
        LD      BC,(D_SIZ)
        RET
GETSIZE2:       ;1DATA/2BYTE
        DEC     A
        SRL     A
        JR      NZ,GETSIZE3
        LD      BC,(D_SIZ)
        SRL     B
        RR      C
        RET
GETSIZE3:
        LD      BC,(D_SIZ)
        RET
;
; ENTRY A:MODE
SWITCH:
        LD      B,A
        ADD     A,A
        ADD     A,A
        ADD     A,A
        ADD     A,A
        SUB     B
        LD      HL,SWBLOCK
        CALL    HLADDA
        LD      DE,CONV1SW1
        LD      BC,9
        LDIR
        LD      DE,CONV1SW2
        LD      BC,3
        LDIR
        RET
;
;       ADPCM to BRZ
SWBLOCK:
SWBLOCK10:
        CALL    CONV1L2
        CALL    CONV1C2
        CALL    CONV1C1
SWBLOCK20:
        CALL    GO1S2
;
;       16BIT PCM to BRZ
;       (SIGNED)
SWBLOCK11:
        CALL    CONV1L1
        CALL    CONV1C1
        NOP
        NOP
        NOP
SWBLOCK21:
        CALL    GO1S1           ;SOURCE
;
;       16BIT PCM to BRZ
;       (UNSIGNED)
SWBLOCK12:
        CALL    CONV1L15
        CALL    CONV1C1
        NOP
        NOP
        NOP
SWBLOCK22:
        CALL    GO1S1           ;SOURCE
;
;       8BIT SIGNED to BRZ
SWBLOCK13:
        CALL    CONV1L3
        CALL    CONV1C3
        NOP
        NOP
        NOP
SWBLOCK23:
        CALL    GO1S3           ;SOURCE
;
;       8BIT UNSIGNED to BRZ(NO OPERATION)
SWBLOCK14:
        CALL    CONV1L3
        LD      B,0
        INC     B               ;NZ
        NOP
        NOP
        NOP
SWBLOCK24:
        CALL    GO1S3           ;SOURCE
;
;       8BIT UNSIGNED(TOWNS) to BRZ
SWBLOCK15:
        CALL    CONV1L3
        CALL    CONV1C4
        NOP
        NOP
        NOP
SWBLOCK25:
        CALL    GO1S3           ;SOURCE
;
XX:     DW      0
YY:     DW      0
;
;
;
HEADER:
        LD      HL,MEMTOP       ;HEADER CLEAR
        LD      DE,MEMTOP+1
        LD      (HL),0
        LD      BC,HDRSIZE-1
        LDIR
;
        LD      DE,MEMTOP+HDR_NAM
        LD      HL,D_SNAME
        LD      BC,8
        LDIR
        LD      HL,(D_SIZ2)
        LD      (MEMTOP+HDR_SIZ),HL
        LD      HL,(D_FREQ2)
        LD      (MEMTOP+HDR_FRQ),HL
        RET
;
;
;
;
; INTERLACE CHECK
; ENTRY HL:COUNTER for INTERLACE
;       DE:DATA1(for SOURCE FREQ.)
;       BC:DATA2(for DESTINATION FREQ.)
; EXIT  NZ:DATA1 go 1STEP
;       NC:DATA2 go 1STEP
ILCHK:
        BIT     7,H
        JR      Z,ILCHK21       ;HL>=0 ?
        ADD     HL,BC
        XOR     A               ;NC,Z
        INC     A               ;NC,NZ
        SCF                     ;C,NZ
        RET
ILCHK21:
        OR      A
        SBC     HL,DE
        XOR     A               ;NC,Z
        RET
;
; ENTRY A:ADPCM DATA(4bits)
;       C:X(0..48)
; EXIT  HL:PCM DATA', C:X'(-1..56)
CNVADTOPW:
        PUSH    AF
        LD      A,C
        ADD     A,A
        LD      HL,TBLXTOD
        CALL    HLADDA
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        LD      L,E
        LD      H,D
        POP     AF
        BIT     3,A
        JR      Z,CNVADTOPW2
        AND     7               ;111B
        CALL    CNVADTOPW2
        JP      NEGHL

;
; CONVERTION ADPCM to 16BIT PCM
; ENTRY A:ADPCM DATA(3bits)
;       HL,DE:DATA D(X)
;       C:INDEX X
; EXIT  HL:FIX( D(X)*C(A)/8 )
;       C:INDEX X
CNVADTOPW2:
        PUSH    HL
        ADD     A,A
        LD      HL,JTBLAD1
        CALL    HLADDA
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        JP      (HL)
JTBLAD1:
        DW      CNVADTOPW20
        DW      CNVADTOPW21
        DW      CNVADTOPW22
        DW      CNVADTOPW23
        DW      CNVADTOPW24
        DW      CNVADTOPW25
        DW      CNVADTOPW26
        DW      CNVADTOPW27
;
CNVADTOPW20:
        POP     HL
        DEC     C
CNVADTOPW209:
;       HL/8
        SRL     H
        RR      L
        SRL     H
        RR      L
        SRL     H
        RR      L
        RET
CNVADTOPW21:
        POP     HL
        ADD     HL,HL
        ADD     HL,DE
        DEC     C
        JR      CNVADTOPW209
CNVADTOPW22:
        POP     HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        DEC     C
        JR      CNVADTOPW209
CNVADTOPW23:
        POP     HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        OR      A
        SBC     HL,DE
        DEC     C
        JR      CNVADTOPW209
CNVADTOPW24:
        POP     HL
        INC     C
        INC     C
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        JR      CNVADTOPW209
CNVADTOPW25:
        POP     HL
        INC     C
        INC     C
        INC     C
        INC     C
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        ADD     HL,DE
        ADD     HL,DE
        JR      CNVADTOPW209
CNVADTOPW26:
        POP     HL
        LD      A,6
        ADD     A,C
        LD      C,A
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        OR      A
        SBC     HL,DE
        SBC     HL,DE
        SBC     HL,DE
        JR      CNVADTOPW209
CNVADTOPW27:
        POP     HL
        LD      A,8
        ADD     A,C
        LD      C,A
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        OR      A
        SBC     HL,DE
        JR      CNVADTOPW209
;
TBLXTOD:
        DW      16,  17,  19,  21,  23,  25,  28,  31,  34,  37,  41,  45,  50
        DW      55,  60,  66,  73,  80,  88,  97, 107, 118, 130, 143, 157, 173
        DW      190,209, 230, 253, 279, 307, 337, 371, 408, 449, 494, 544, 598
        DW      658,724, 796, 875, 963,1060,1166,1282,1411,1552
;
; ENTRY C:X(-1..56)
; EXIT  C:X(0..48)
XCLIP:
        LD      A,C
        CP      255             ;'-1'
        JR      NZ,XCLIP2
        INC     C               ;255+1=0
        RET
XCLIP2:
        CP      49
        RET     C
        LD      C,48
        RET

;
; CONVERTION 16BIT PCM to 8 BIT
;            with CLIPPING
; ENTRY HL:PCM DATA(16bits) unsigned
;       A:EXPAND RATIO
;       DE:OFFSET( < 0 )
; EXIT  A:PCM DATA(8bits)
;       Z:CLPIPED OUT, NZ:NOT CLIPPED
CNVPWTOPH:
        PUSH    DE
        LD      D,0
        LD      E,A
        CALL    DIV16
        POP     DE
        ADD     HL,DE
        BIT     7,H
        JR      NZ,CNVPWTOPH921
        LD      A,H
        OR      A
        JR      NZ,CNVPWTOPH922
CNVPWTOPH91:
        XOR     A
        INC     A
        LD      A,L
        RET
CNVPWTOPH921:
        XOR     A
        RET
CNVPWTOPH922:
        XOR     A
        LD      A,255
        RET
;
;       CLEAR 'SMTBL'
;
CSMTBL:
        LD      HL,SMTBL
        LD      A,(D_SMN)
        LD      B,A
CSMTBL11:
        LD      (HL),$80
        INC     HL
        DJNZ    CSMTBL11
        RET
;
;       PUT DATA to 'SMTBL'
; ENTRY A:DATA, (D_SMP)
PUTSMTBL:
        PUSH    AF
        LD      HL,D_SMP
        LD      A,(HL)
        LD      DE,SMTBL
        CALL    DEADDA
        POP     AF
        LD      (DE),A
        INC     (HL)
        LD      A,(D_SMN)
        DEC     A               ;D_SMN>0!!
        CP      (HL)
        RET     NC              ;(D_SMN)>(D_SMP)?
        LD      (HL),0          ;POINTER RESET
        RET
;
;       GET DATA from 'SMTBL'
; EXIT  A:SMOOTHED DATA from 'SMTBL'
GETSMTBL:
        LD      HL,SMTBL
        LD      A,(D_SMN)
        CP      1
        JR      Z,GETSMTBL2     ;D_SMN=1?
        LD      B,A
        LD      DE,0            ;SUM
GETSMTBL11:
        LD      A,(HL)
        INC     HL
        CALL    DEADDA
        DJNZ    GETSMTBL11
        EX      DE,HL           ;SUM=HL
        LD      A,(D_SMN)
        CP      2
        JR      Z,GETSMTBL3     ;(D_SMN)=2?
        LD      E,A
        LD      D,0
        CALL    DIV16           ;SUM/(D_SMN)
        LD      A,L
        RET
GETSMTBL2:
        LD      A,(HL)
        RET
GETSMTBL3:
        SRL     H
        RR      L
        LD      A,L
        RET

;
;HPC File Loader
; PCM2BRZ VERSION
;
; EXIT  Z:BRKEY
;       C:ERROR
;
LOAD1:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "SOURCE FILE NAME?",$00
        CALL    INPUTS1
        LD      DE,BFFN1
        CALL    #MSX
        CALL    INPUTS2
        JP      Z,LOAD193       ;CANCEL
;
        CALL    SKPSP
        LD      A,(DE)
        CP      $00
        JR      Z,LOAD12
        LD      (BFDE1),DE
        CALL    SKPCL
        JP      C,LOAD129
        LD      (#DSK),A
        LD      A,(DE)
        CP      $00
        JR      Z,LOAD12
        LD      DE,(BFDE1)
        JR      LOAD129
;       INPUT NULL FILE
LOAD12:
        CALL    #DIR
        JR      NC,LOAD122
;       ERROR
        CALL    ERR
        CALL    #MPRNT
        DB      "CAN'T GET DIR",$0D,$00
        JP      LOAD192
LOAD122:
        CALL    KEYWAIT
        CALL    #CSR
        LD      (BFCSR1),HL
        CALL    #MPRNT
        DB      "=== HIT <CR> ON FILENAME. =============",$00
        LD      HL,(BFCSR1)
        CALL    #LOC
        LD      DE,(#KBFAD)
        CALL    #GETL
        PUSH    DE
        LD      HL,(BFCSR1)
        CALL    #LOC
        CALL    #LTNL
        POP     DE
        LD      A,(DE)
        CP      $1B
        JP      Z,LOAD1         ;CANCEL
        LD      A,5
        CALL    DEADDA          ;DUMMY
LOAD129:
        LD      (BFDE1),DE
;
        CALL    CUTFN
        LD      HL,(BFDE1)
        LD      DE,BFFN1
        CALL    TRSTR
        LD      HL,BFFN1
        LD      DE,BFFN2
        PUSH    HL
        CALL    DFLTFN2
        POP     HL              ;HL=BFFN1
        LD      DE,D_SNAME
        CALL    DFLTSN
LOAD15:
        LD      DE,BFFN1
        PUSH    DE
        LD      A,ATR_BIN
        LD      (BFATR),A
        CALL    #FILE
;       CALL    #FPRNT
        CALL    #ROPEN
        POP     DE
        JR      NC,LOAD16
        LD      A,ATR_ASC
        LD      (BFATR),A
        CALL    #FILE
;       CALL    #FPRNT
        CALL    #ROPEN
        CALL    C,ERR
        JR      C,LOAD192       ;ERROR
LOAD16:
;       FILE SIZE CHECK
        LD      HL,(MEMSIZE)
        LD      DE,(#SIZE)
        OR      A
        SBC     HL,DE
        JR      NC,LOAD169
        CALL    #MPRNT
        DB      "ERROR:FILE TOO BIG",$0D
        DB      " FILE SIZE:",$00
        LD      HL,(#SIZE)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES",$0D,$00
        LD      HL,(MEMSIZE)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES FREE",$0D,$00
        JR      LOAD192
LOAD169:
        LD      HL,(#MEMAX)
        LD      DE,(#SIZE)
        OR      A
        SBC     HL,DE
        LD      (MEMADR2),HL
        LD      (#DTADR),HL
;
;       FILE OPEN SUCCEED
LOAD191:
        XOR     A               ;Z,NC
        INC     A               ;NZ,NC
        RET
;
;       FILE OPEN FAILURE
LOAD192:
        CALL    #MPRNT
        DB      "FILE CAN'T OPEN",$0D,$00
        XOR     A
        INC     A               ;NZ,NC
        SCF
        RET
;
;       CANCEL
LOAD193:
        XOR     A               ;Z,NC
        RET
;
;
;EXIT   C:ERROR
;
LOAD2:
;       FILE READ
        CALL    #RDD
        CALL    C,ERR
        JR      C,LOAD292
;
;       NO ERROR
        LD      HL,(#SIZE)
        LD      (FSIZE1),HL
        XOR     A
        INC     A               ;NZ,NC
        RET
;       ERROR
LOAD292:
        SCF                     ;CY
        RET
;
;
;HPC File Saver
;
; EXIT  Z:BRKEY
;
SAVE1:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "DESTINATION FILE NAME?",$00
        CALL    INPUTS1
        LD      DE,BFFN2
        CALL    #MSX
        CALL    INPUTS2
        RET     Z               ;CANCEL
;
        EX      DE,HL           ;HL=(#KBFAD)
        LD      DE,BFFN2
        LD      (BFDE2),DE
        CALL    TRSTR
        XOR     A
        INC     A
        RET                     ;NZ
;
;
;EXIT   C:ERROR
;
SAVE2:
        LD      DE,(BFDE2)
        PUSH    DE
        LD      A,ATR_BIN
        CALL    #FILE
        CALL    #ROPEN
        POP     DE
        JR      NC,SAVE21
        LD      A,ATR_ASC
        CALL    #FILE
        CALL    #ROPEN
        JR      C,SAVE22
;       ALREADY EXIST
SAVE21:
        CALL    #MPRNT
        DB      "WARNING!:FILE ALREADY EXIST",$0D,$00
;       FILE OPEN & WRITE
SAVE22:
        LD      HL,(FSIZE2)
        LD      (#SIZE),HL
        LD      HL,DATATOP      ;on FILE
        LD      (#DTADR),HL
        LD      HL,#HOT
        LD      (#EXADR),HL
;
        LD      A,(BFATR)
        LD      DE,(BFDE2)
        CALL    #FILE
;       CALL    #FPRNT
        CALL    #WOPEN
        CALL    C,ERR
        JR      C,SAVE292       ;ERROR
;       FILE OPEN SUCCEED
;       FILE WRITE
        LD      HL,MEMTOP       ;on MEMORY
        LD      (#DTADR),HL
        CALL    #WRD
        CALL    C,ERR
        JR      C,SAVE292       ;ERROR
;
;       NO ERROR
SAVE291:
        XOR     A               ;NC
        RET
;       ERROR
SAVE292:
        CALL    #MPRNT
        DB      "FILE CAN'T WRITE",$0D,$00
        SCF                     ;CY
        RET
;
;       CUT FILE NAME
;       ENTRY   DE:STR.ADR
CUTFN:
        PUSH    DE
        PUSH    DE
        CALL    SKPSP
        EX      DE,HL           ;LD HL,DE
        POP     DE
CUTFN105:
        LD      A,(HL)
        LD      (DE),A
        INC     HL
        INC     DE
        OR      A
        JR      NZ,CUTFN105
        POP     DE              ;LD DE,HL
;
        INC     DE
        LD      A,(DE)
        CP      ":"
        JR      Z,CUTFN11
        DEC     DE
        DEC     DE
CUTFN11:
        INC     DE
        CALL    SKPCL
        JR      C,CUTFN12
        DEC     DE
        XOR     A
        LD      (DE),A          ;END CODE
CUTFN12:
        RET
;
;       SKIP SPC
;       ENTRY   DE:STR. ADR
;       EXIT    DE:STR. ADR
SKPSP:
        LD      A,(DE)
        CP      $20             ;SPC. CODE
        RET     NZ
        INC     DE
        JR      SKPSP
;
; SKIP into COLON
; ENTRY DE:STR. ADR
; EXIT  DE:STR. ADR
;       CY:NO COLON
SKPCL:
        PUSH    BC
        PUSH    DE
        LD      B,0
SKPCL11:
        LD      A,(DE)
        CP      ":"
        JR      Z,SKPCL91
        OR      A
        JR      Z,SKPCL92
        LD      B,A
        INC     DE
        JR      SKPCL11
SKPCL91:
        LD      A,B
        INC     DE
        OR      A
        POP     BC              ;DUMMY
        JR      SKPCL99
SKPCL92:
        XOR     A               ;LD A,0
        SCF                     ;NO COLON
        POP     DE
SKPCL99:
        POP     BC
        RET
;
; ENTRY HL:KBFAD,DE:BFFN
;               ($00:END)
TRSTR:
        LD      B,32            ;MAX LENGTH
TRSTR11:
        LD      A,(HL)
        LD      (DE),A
        INC     HL
        INC     DE
        OR      A
        RET     Z
        DJNZ    TRSTR11
        RET
;
; ENTRY HL:BFFN1
;       DE:BFFN2
DFLTFN2:
        EX      DE,HL
        CALL    SKPDV
        CALL    TRSFN2
        EX      DE,HL
        LD      HL,EXPSTR
        LD      BC,5
        LDIR
        RET
;
; TRANS FILE NAME (DE-) to (HL-) only PRIMARY
; ENTRY DE:STR.ADR.
; EXIT  HL:PRIMARY NAME(LENGTH_PRIMARY)
TRSFN2:
        LD      B,(LENGTH_PRIMARY)
        LD      B,A
TRSFN21:
        LD      A,(DE)
        CP      "."
        JR      Z,TRSFN22
        CP      $00
        JR      Z,TRSFN22
        LD      (HL),A
        INC     DE
        INC     HL
        DJNZ    TRSFN21
        JR      TRSFN29
TRSFN22:
        LD      (HL),$20
        INC     HL
        DJNZ    TRSFN21
TRSFN29:
        RET
;
EXPSTR: DB      ".BRZ",$00
;
; ENTRY HL:BFFN1
;       DE:D_SNAME
DFLTSN:
        EX      DE,HL
        CALL    SKPDV
        LD      B,8
        JR      TRSFN21
;
; ENTRY DE:STR.ADR.
; EXIT  DE:STR.ADR.(NEXT by CORON)
SKPDV:
        INC     DE
        LD      A,(DE)
        DEC     DE
        CP      ":"             ;CORON
        JR      NZ,SKPDV12
        INC     DE
        INC     DE
SKPDV12:
        RET
;
; ENTRY DE:DATA1, A:DATA2(>0)
; EXIT  DE:DATA1+DATA2
DEADDA:
        ADD     A,E
        LD      E,A
        LD      A,D
        ADC     A,0
        LD      D,A
        RET
;
;
ERR:
        PUSH    AF
        CALL    #MPRNT
        DB      "ERROR:",$00
        POP     AF
        RET
;
;
KEYWAIT:
        CALL    #GETKY
        OR      A
        JR      NZ,KEYWAIT
        RET
;
;       EXIT    A:KEYCODE
;               Z:BRKEY
GET1CHR:CALL    #GETKY
        OR      A
        JR      NZ,GET1CHR
        CALL    #INKEY
        CP      $20
        JR      C,GET1CHR91
        PUSH    AF
        CALL    #PRINT
        POP     AF
GET1CHR91:
        CP      $03     ;BRKEY=Z
        RET             ;NZ
;
;       DS      128
;USRSTK:
;
CODE_END:
MEMTOP:
;
;[EOF]
