;PCM2BRZ1.ASM
;
; PCM DATA CONVERTER for BREEZE
;on S-OS "SWORD" or "SWORD" compatible  OS
;V1.00
;
;
;from
; 4bit AD-PCM DATA(from 'X68K') ,
; 16bit PCM DATA(linear signed,big-endian) ,
; 16bit PCM DATA(linear signed,small-endian) ,
; 8bit PCM DATA(linear signed) ,
; 8bit PCM DATA(linear unsigned) ,
; 8bit PCM DATA(FM 'TOWNS' '.SND')
;to 8bit PCM DATA(BREEZE)
;
;
; S-OS SYSTEM CALL
;
#HOT    EQU     $1FFA
#VER    EQU     $1FF7
#PRINT  EQU     $1FF4
#PRNTS  EQU     $1FF1
#LTNL   EQU     $1FEE
#MSX    EQU     $1FE5
#MPRNT  EQU     $1FE2
#GETL   EQU     $1FD3
#GETKY  EQU     $1FD0
#BRKEY  EQU     $1FCD
#INKEY  EQU     $1FCA
#PRTHL  EQU     $1FBE
#WOPEN  EQU     $1FAF
#WRD    EQU     $1FAC
#RDD    EQU     $1FA6
#FILE   EQU     $1FA3
#FPRNT  EQU     $1F9D
#DIR    EQU     $2006
#ROPEN  EQU     $2009
#CSR    EQU     $2018
#LOC    EQU     $201E
;
; S-OS SYSTEM WORK
;
#KBFAD  EQU     $1F76
#SIZE   EQU     $1F72
#DTADR  EQU     $1F70
#EXADR  EQU     $1F6E
#MEMAX  EQU     $1F6A
#DSK    EQU     $1F5D
;
;
ENTRY   EQU     $3000
;MEMTOP =CODE_END
;
HDRSIZE EQU     32      ;SDAC (check! SDAC REFERENCE out)
HDR_NAM EQU     0
HDR_SIZ EQU     8
HDR_FRQ EQU     12
HDR_RSV EQU     16
;
DATATOP EQU     $3000           ;for FILE
MAXSPEC EQU     6               ;5+1
MAXSMN  EQU     16
ATR_BIN EQU     1
ATR_ASC EQU     4
;
;
        ORG     ENTRY
        OFFSET  $C000-ENTRY
;
;
START:
;       LD      (BFSTACK),SP
;       LD      SP,USRSTK
CREDIT:
        CALL    #MPRNT
        DB      "********************",$0D
        DB      " PCM DATA CONVERTER ",$0D
        DB      "   FROM SOME TYPES  ",$0D
        DB      "     TO BREESE      ",$0D
        DB      "               V1.00",$0D
        DB      "********************",$0D
        DB      "    #MEMAX:",$00
        LD      HL,(#MEMAX)
        CALL    #PRTHL
        CALL    #LTNL
;
        LD      HL,(#MEMAX)
        LD      DE,CODE_END
        OR      A
        SBC     HL,DE
        LD      (MEMSIZE),HL
;
        LD      HL,MEMTOP
        LD      (MEMADR1),HL
;
        LD      A,13
        LD      (LENGTH_PRIMARY),A
        CALL    #VER
        BIT     7,L
        JR      Z,MLOP1
;       L-OS!
        LD      A,8
        LD      (LENGTH_PRIMARY),A
MLOP1:
        CALL    CONV
        JR      NZ,MLOP1
QUIT:
;       LD      SP,(BFSTACK)
        XOR     A
        RET
;
; WORK
;
LENGTH_PRIMARY: DB      13      ;13:S-OS 8:L-OS
;
MEMSIZE:DW      0
MEMADR1:DW      0       ;=MEMTOP
MEMADR2:DW      0       ;SHIFTED to LOWER ADR
;
D_SIZ:  DW      0
D_SIZ2: DW      0
D_SIZR: DW      0               ;REMAINING
D_FREQ: DW      15600
D_FREQ2:DW      15600
D_SNAME:DS      8
        DB      $00
;
D_MGETA:DW      3
D_CENT: DW      0
D_OVER: DW      0
D_MODE: DB      0
D_MODE3:DB      0
D_ERR:  DB      0
D_ILCNT:DW      0
D_EVEN: DB      0
D_SMN:  DB      0
D_SMP:  DB      0
;
FSIZE1: DW      0       ;LOAD FILE
FSIZE2: DW      0       ;SAVE FILE
;
BFSTACK:DW      0
BFCSR1: DW      0
BFATR:  DB      0
BFDE1:  DW      0
BFDE2:  DW      0
BFFN1:  DS      32
BFFN2:  DS      32
SMTBL:  DS      MAXSMN
;
;[EOF]
;PCM2BRZ2.ASM
;
;
;
; EXIT  Z:BRKEY
CONV:
        XOR     A               ;ENDCODE
        LD      (BFFN1),A       ;CLEAR
CONV000:
        CALL    LOAD1
        JP      Z,CONV092       ;CANCEL
        JR      C,CONV          ;ERROR
CONV001:
;       DEFAULT
        LD      DE,BFFN1
        CALL    DFLTMODE
        LD      (D_MODE),A
        CALL    #MPRNT
        DB      "*",$0D
;       DB      "TYPE OF SOURCE-DATA",$0D
        DB      "(0:ADPCM X68K",$0D
        DB      "/1:16BIT,SIGNED,BIG-ENDIAN",$0D
        DB      "/2:16BIT,LITTLE-ENDIAN",$0D
        DB      "/3:8BIT,SIGNED",$0D
        DB      "/4:8BIT,UNSIGNED",$0D
        DB      "/5:8BIT,FLAG+ABS.)",$0D,$00
CONV0015:
        CALL    #MPRNT
        DB      "TYPE OF SOURCE-DATA?",$00
        CALL    INPUTS1
        LD      HL,(D_MODE)
        LD      H,0
        CALL    PRTDECI
        CALL    INPUTS2
        JP      Z,CONV000       ;CANCEL
        CALL    DECITOHL
        LD      DE,MAXSPEC
        OR      A
        SBC     HL,DE
        ADD     HL,DE
        JR      NC,CONV0015     ;MODE>=MAXSPEC?
        LD      A,L
        LD      (D_MODE),A
;
CONV002:
        CALL    SAVE1
        JP      Z,CONV000       ;CANCEL
;
CONV01:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "SOUND NAME?",$00
        CALL    INPUTS1
        LD      DE,D_SNAME
        CALL    #MSX
        CALL    INPUTS2
        JP      Z,CONV000       ;CANCEL
        EX      DE,HL
        LD      DE,D_SNAME
        PUSH    DE
        LD      BC,8
        LDIR
        POP     DE
        CALL    FILSPC
CONV012:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "SAMPLING RATE(1..32767Hz)?",$00
        CALL    INPUTS1
        LD      HL,(D_FREQ)
        CALL    PRTDECI
        CALL    INPUTS2
        JP      Z,CONV000       ;CANCEL
        CALL    DECITOHL
        LD      A,H
        OR      L
        JR      Z,CONV012       ;FREQ=0?
        LD      (D_FREQ),HL
        BIT     7,H
        JR      NZ,CONV012      ;FREQ>32767?
;
CONV013:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "PLAYING  RATE(1..32767Hz)?",$00
        CALL    INPUTS1
        LD      HL,(D_FREQ2)
        CALL    PRTDECI
        CALL    INPUTS2
        JP      Z,CONV000       ;CANCEL
        CALL    DECITOHL
        LD      A,H
        OR      L
        JR      Z,CONV013       ;FREQ2=0?
        BIT     7,H
        JR      NZ,CONV013      ;FREQ2>32767?
;
CONV014:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "ATTENUATION RATE(1..255)?",$00
        CALL    INPUTS1
        LD      HL,(D_MGETA)
        CALL    PRTDECI
        CALL    INPUTS2
        JP      Z,CONV000       ;CANCEL
        CALL    DECITOHL
        LD      A,H
        OR      L
        JR      Z,CONV014       ;ATT.RATE=0?
        LD      A,H
        OR      A
        JR      NZ,CONV014      ;ATT.RATE>255?
        LD      (D_MGETA),HL
CONV015:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "EZ-SMOOTHING ON(Y/N)?",$00
        CALL    YESNO
        JP      Z,CONV000       ;CANCEL
        LD      A,$00
        ADC     A,$00
        LD      (D_MODE3),A     ;YES=0
;
        CALL    #MPRNT
        DB      "*",$0D
        DB      "NOW CONVERTING!",$0D,$00
        XOR     A
        LD      (D_ERR),A       ;RESET
;
;       SOURCE FILE LOAD
        CALL    LOAD2
        JP      C,CONV091       ;ERROR
;       SIZE PARAMETER
        LD      HL,(FSIZE1)
        LD      (D_SIZ),HL
        CALL    CONV1
;       LD      HL,(D_SIZ2)
;       DEC     HL
;       LD      (D_SIZ2),HL
;
;       ERR?
        LD      A,(D_ERR)
        OR      A
        JR      Z,CONV018
        CALL    #MPRNT
        DB      "ERROR:MEMORY SHORT",$0D,$00
        LD      HL,(D_SIZR)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES REMAIN",$0D,$00
        JP      CONV091         ;ERROR
CONV018:
;       PROCESSED DATA SIZE
        LD      HL,(D_SIZ2)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES PROCESSED",$0D,$00
;       CLIPPED OUT DATA SIZE
        LD      HL,(D_OVER)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES CLIPPED OUT",$0D,$00
;
        CALL    HEADER
;       SAVE SIZE
        LD      HL,(D_SIZ2)
        LD      DE,HDRSIZE
        ADD     HL,DE
        LD      (FSIZE2),HL
;       ADDRESS INFO.
        CALL    #MPRNT
        DB      "ADDRESS ",$00
        LD      HL,DATATOP
        CALL    #PRTHL
        LD      A,":"
        CALL    #PRINT
        LD      HL,DATATOP
        LD      DE,(FSIZE2)
        ADD     HL,DE
        DEC     HL
        CALL    #PRTHL
        CALL    #MPRNT
        DB      ":1FFA",$0D,$00
;
        CALL    SAVE2
;       JR      C,CONV091
;       JR      Z,CONV023
CONV091:
        XOR     A
        INC     A               ;NZ
        RET
CONV092:
        XOR     A               ;Z
        RET
;
;
INPUTS1:
        CALL    #CSR
        LD      (BFCSRS),HL
        RET
;
; EXIT  Z:CANCEL, NZ:NORMAL
;
INPUTS2:
        LD      HL,(BFCSRS)
        CALL    #LOC
        LD      DE,(#KBFAD)
        CALL    #GETL
        LD      A,(DE)
        CP      $1B
        RET     Z               ;Z:CANCEL
        CALL    SRCMRK
;       RET     C               ;ERR?
        XOR     A               ;NZ
        INC     A
        RET
;
BFCSRS: DW      0
;
;
; SEARCH INPUT MARK '?'
; ENTRY DE:STR. ADR.
; EXIT  DE:NEXT INPUT MARK ADR.
;       CY:ERR, NC:NORMAL
SRCMRK:
        LD      A,(DE)
        INC     DE
        CP      $00
        JR      Z,SRCMRK92
        CP      '?'
        JR      NZ,SRCMRK
SRCMRK91:
        OR      A
        RET
SRCMRK92:
        SCF
        RET
;
; ENTRY DE:STR. ADR.(8chr.)
FILSPC:
        LD      B,8
FILSPC11:
        LD      A,(DE)
        CP      $00
        JR      Z,FILSPC13
        CP      $A0
        JR      Z,FILSPC13
FILSPC12:
        INC     DE
        DJNZ    FILSPC11
        RET
FILSPC13:
        LD      A,$20
        LD      (DE),A
        JR      FILSPC12
;
;ENTRY  DE:FILENAME
;EXIT   A:TYPE OF DATA
;
DFLTMODE:
;       SEARCH '.'
        LD      A,(LENGTH_PRIMARY)
        ADD     A,3             ;2+1
        LD      B,A
DFLTMODE11:
        LD      A,(DE)
        CP      "."
        JR      Z,DFLTMODE2
        OR      A               ;ZERO?
        JR      Z,DFLTMODE92
        INC     DE
        DJNZ    DFLTMODE11
;       NO '.'
        JR      DFLTMODE92
DFLTMODE2:
        INC     DE
;       CHECK TBL
        LD      HL,TYPETBL
DFLTMODE21:
        PUSH    DE
        LD      A,(DE)
        CP      (HL)
        JR      NZ,DFLTMODE251  ;NOT
        INC     DE
        INC     HL
        LD      A,(DE)
        CP      (HL)
        JR      NZ,DFLTMODE252  ;NOT
        INC     DE
        INC     HL
        LD      A,(DE)
        CP      (HL)
        JR      NZ,DFLTMODE253  ;NOT
;       HIT!!
        INC     HL
        LD      A,(HL)
        POP     DE
        RET
DFLTMODE251:
        INC     HL
DFLTMODE252:
        INC     HL
DFLTMODE253:
        INC     HL
        POP     DE
        LD      A,(HL)
        INC     HL
        CP      255             ;END?
        JP      NZ,DFLTMODE21
DFLTMODE92:
        XOR     A
        RET
;
TYPETBL:
        DB      "P16",1 ;16BIT SIGNED,BIG-ENDIAN
        DB      "PHL",1
        DB      "PLH",2 ;16BIT SIGNED,LITTLE-ENDIAN
        DB      "PCM",0 ;4BIT ADPCM(X68K)
        DB      "PC8",3 ;8BIT SIGNED
        DB      "PN8",4 ;8BIT UNSIGNED
        DB      "PS8",5 ;8BIT FLAGBIT(1BIT)+ABSOLUTE(7BIT)
        DB      "???",255
;
;       EXIT    C:NO,NC:YES
;               Z:BRKEY
YESNO:
        CALL    #CSR
        LD      (BFCSR1),HL
YESNO2:
        LD      HL,(BFCSR1)
        CALL    #LOC
        CALL    GET1CHR
        CP      "Y"
        JR      Z,YESNO3
        CP      "y"
        JR      Z,YESNO3
        CP      " "
        JR      NZ,YESNO25
        LD      A,"Y"
        CALL    #PRINT
        JR      YESNO3
YESNO25:
        CP      "N"
        JR      Z,YESNO4
        CP      "n"
        JR      Z,YESNO4
        CP      13              ;<CR>
        JR      NZ,YESNO28
        LD      A,"N"
        CALL    #PRINT
        JR      YESNO4
YESNO28:
        CP      $03             ;CANCEL
        JR      NZ,YESNO2
        JR      YESNO9          ;Z
YESNO3:
        OR      A               ;NZ
        JR      YESNO9
YESNO4:
        OR      A               ;-Z
        SCF
YESNO9:
        PUSH    AF
        CALL    #LTNL
        POP     AF
        RET
;
;
; ENTRY DE:STR. ADR.(NULL END)( < 5COLUMNs)
; EXIT  HL:DATA(NUMERIC)
DECITOHL:
        LD      HL,0
        LD      B,5             ;COUNTER,5COLUMNS
DECITOHL11:
        LD      A,(DE)
        CP      $00
        RET     Z
        INC     DE
        SUB     "0"
        CALL    HLMULDECA
        CALL    HLADDA
        DJNZ    DECITOHL11
        RET
;
; ENTRY HL:NUMERIC DATA
; EXIT  HL:NUMERIC DATA*10
HLMULDECA:
        PUSH    BC
        ADD     HL,HL
        LD      C,L
        LD      B,H
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,BC
        POP     BC
        RET
;
;       PRTHL on DECIMAL
; ENTRY HL:DATA(DECIMAL)
PRTDECI:
        LD      DE,DECITBL
        LD      B,5             ;COUNTER ,5COLUMNS
        LD      C,0             ;FLG
        EX      DE,HL
PRTDECI11:
        PUSH    BC
        LD      C,(HL)
        INC     HL
        LD      B,(HL)
        INC     HL
        XOR     A
        EX      DE,HL
PRTDECI12:
        SBC     HL,BC
        JR      C,PRTDECI2
        INC     A
        JR      PRTDECI12
PRTDECI2:
        ADD     HL,BC
        POP     BC
        OR      A
        JR      NZ,PRTDECI21
        BIT     0,C
        JR      NZ,PRTDECI21
        JR      PRTDECI29
PRTDECI21:
        LD      C,1
        ADD     A,"0"           ;DECIMAL ON CHR
        CALL    #PRINT
PRTDECI29:
        EX      DE,HL
        DJNZ    PRTDECI11
        BIT     0,C
        RET     NZ
        LD      A,"0"
        JP      #PRINT
;
DECITBL:
        DW    10000,1000,100,10,1
;
; 'WARIZAN'
; ENTRY HL:'WARARERU'
;       DE:'WARU'
; EXIT  HL:RESULT
DIV16:  PUSH    BC
        LD      A,16
        LD      C,E
        LD      B,D
        EX      DE,HL
        LD      HL,0
DIV162: ADD     HL,HL
        EX      DE,HL
        ADD     HL,HL
        EX      DE,HL
        JP      NC,DIV163
        INC     HL
DIV163: OR      A
        SBC     HL,BC
        JP      NC,DIV164
        ADD     HL,BC
        JP      DIV165
DIV164: INC     DE
DIV165: DEC     A
        JP      NZ,DIV162
        EX      DE,HL
        POP     BC
        RET
;
; ENTRY HL,A
; EXIT  HL:HL+A
HLADDA:
        ADD     A,L
        LD      L,A
        LD      A,H
        ADC     A,0
        LD      H,A
        RET
;
; ENTRY HL:DATA
; EXIT  HL:-DATA
NEGHL:
        EX      DE,HL
        LD      HL,0
        OR      A
        SBC     HL,DE
        RET
;
;[EOF]
;PCM2BRZ3.ASM
;
;
; CONVERT
;
CONV1:
        LD      HL,0
        LD      (D_OVER),HL
        LD      (XX),HL         ;ADPCM to PCM
        LD      H,$80           ;HL=32768
        LD      (YY),HL
        LD      DE,(D_MGETA)    ;OFFSET(16b to 8b)
        CALL    DIV16
        CALL    NEGHL
        LD      A,128
        CALL    HLADDA
        LD      (D_CENT),HL
        LD      HL,(D_FREQ)     ;for INTERACE
        SRL     H
        RR      L
        LD      (D_ILCNT),HL
        XOR     A
        LD      (D_EVEN),A      ;'EVEN'
        LD      (D_SMP),A       ;for SMOOTHING
        LD      HL,(D_FREQ)
        DEC     HL
        LD      DE,(D_FREQ2)
        CALL    DIV16
        LD      A,L
        INC     A               ;D_SMN>0
        CP      MAXSMN
        JR      C,CONV105       ;D_SMN<MAXSMN?
        LD      A,MAXSMN-1
CONV105:
        LD      (D_SMN),A
        CALL    CSMTBL
;
        LD      A,(D_MODE)
        CALL    SWITCH
;
        LD      HL,(MEMADR2)            ;SOURCE
        LD      DE,MEMTOP+HDRSIZE       ;DISTINATION
        CALL    GETSIZE
CONV11:
        EXX
        LD      HL,(D_ILCNT)
        LD      DE,(D_FREQ)
        LD      BC,(D_FREQ2)
        CALL    ILCHK
        LD      (D_ILCNT),HL
        JR      Z,CONV12
        EXX
CONV1SW1:                       ;SWITCHING BLOCK(12BYTES)
;       CONVERT
        CALL    CONV1L2         ;INCLUDING 'EXX'
        CALL    CONV1C2
        CALL    CONV1C1
;
        JR      NZ,CONV111      ;NOT CLIPPED OUT?
        LD      HL,(D_OVER)
        INC     HL
        LD      (D_OVER),HL
CONV111:
        LD      (CONVBF1),A     ;8BIT PCM
        LD      HL,D_MODE3
        BIT     0,(HL)
        JR      NZ,CONV112
;       SMOOTHING
        CALL    PUTSMTBL        ;
CONV112:
        EXX
CONV1SW2:                       ;3BYTES
;       SOURCE GO 1STEP
        CALL    GO1S2           ;SOURCE
;
        JR      Z,CONV19        ;SOURCE END?
        JR      CONV11
CONV12:
;       DESTINATION GO 1STEP
        LD      A,(CONVBF1)
        LD      HL,D_MODE3
        BIT     0,(HL)
        JR      NZ,CONV121
;       SMOOTHING
        CALL    GETSMTBL
CONV121:
        EXX
        LD      (DE),A          ;DESTINATION
        INC     DE
        OR      A
        EX      DE,HL
        SBC     HL,DE
        ADD     HL,DE
        EX      DE,HL
        JR      C,CONV122       ;NOT MEMORY OVER?
        LD      A,1
        LD      (D_ERR),A       ;MEMORY OVER
        JR      CONV19
CONV122:
        JP      CONV11
CONV19:
        LD      (D_SIZR),BC     ;REMAINING DATA SIZE
        EX      DE,HL
        LD      DE,MEMTOP+HDRSIZE
        OR      A
        SBC     HL,DE
        LD      (D_SIZ2),HL     ;PROCCESSED DATA SIZE
        RET
CONVBF1:
        DB      0

;
; CONVERT 16BIT to 8 BIT
;        (UNSIGNED)   (BREEZE)
; ENTRY HL:PCMDATA(0-65535)
; EXIT  A:PMDATA(0-255)
;       Z:CLIPPED
CONV1C1:
        LD      A,(D_MGETA+0)
        LD      DE,(D_CENT)
        CALL    CNVPWTOPH
        RET
;
; CONVERT 4BIT to 16BIT
;          (ADPCM)  (UNSIGNED)
; ENTRY A:ADPCM DATA
;       (XX):INDEX(0-48)
;       (YY):PCM DATA
; EXIT  HL,(YY):PCM DATA
;       (XX):INDEX(0-48)
CONV1C2:
        LD      BC,(XX)         ;B reg. is DMY
        CALL    CNVADTOPW
        CALL    XCLIP
        LD      DE,(YY)
        ADD     HL,DE
        LD      (YY),HL
        LD      A,C
        LD      (XX),A
        RET
;
; CONVERT 8BIT to 8 BIT
;        (SIGNED)   (UNSIGNED,BREEZE)
; ENTRY A:PCMDATA(-128..127)
; EXIT  A:PMDATA(0-255)
;       Z:CLIPPED
CONV1C3:
        ADD     A,$80
        LD      B,0             ;??
        INC     B               ;NZ NO CLIPPING
        RET
;
; CONVERT 8BIT to 8 BIT
;        (TOWNS)   (UNSIGNED,BREEZE)
; ENTRY A:PCMDATA(+/- 0..127)
; EXIT  A:PMDATA(1-255)
;       Z:CLIPPED
CONV1C4:
        BIT     7,A
        JP      Z,CONV1C41
        XOR     $7F
        INC     A
CONV1C41:
        ADD     A,$80
        LD      B,0             ;??
        INC     B               ;NZ NO CLIPPING
        RET
;
; DATA LOAD 16BIT DATA(BIG-ENDIAN,
;                       SIGNED)
; ENTRY HL:DATA ADR.
; EXIT  HL':DATA(UNSIGNED,0-65535)
CONV1L1:
        LD      A,128   ;+32768
        ADD     A,(HL)  ;BIG-ENDIAN
        PUSH    AF
        INC     HL
        LD      A,(HL)
        DEC     HL
        EXX
        LD      L,A
        POP     AF
        LD      H,A
        RET
;
; DATA LOAD 16BIT DATA(LITTLE-ENDIAN,
;                       SIGNED)
; ENTRY HL:DATA ADR.
; EXIT  HL':DATA(UNSIGNED,0-65535)
CONV1L15:
        LD      A,128
        ADD     A,(HL)  ;LITTLE-ENDIAN
        PUSH    AF
        INC     HL
        LD      A,(HL)
        DEC     HL
        EXX
        LD      H,A     ;LITTLE-ENDIAN!!
        POP     AF
        LD      L,A
        RET
;
; DATA LOAD 4BIT DATA(HIGH>>>LOW)
; ENTRY HL:DATA ADR.
;       (D_EVEN):EVEN|ODD
; EXIT  (D_EVEN):(D_EVEN)+1 MOD 2
;       A:4BIT DATA
CONV1L2:
        LD      A,(D_EVEN)
        XOR     1               ;BIT0 REVERSE
        LD      A,(HL)
        JR      NZ,CONV1L21:
        RRA
        RRA
        RRA
        RRA
CONV1L21:
        AND     1111B           ;MASK
        EXX
        RET
;
; DATA LOAD 8BIT DATA
; ENTRY HL:DATA ADR.
; EXIT  A:8BIT DATA
CONV1L3:
        LD      A,(HL)
        EXX
        RET
;
; GO 1 STEP (SOURCE=16BIT PCM)
; ENTRY HL:SOURCE ADR.
; EXIT  HL:SOURCE ADR.+2
;       Z:SOURCE END
GO1S1:
        INC     HL
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        RET
;
; GO 1 STEP (SOURCE=4BIT ADPCM)
; ENTRY HL:SOURCE ADR.
;       (D_EVEN):EVEN|ODD
; EXIT  HL:SOURCE ADR.|SOURCE ADR.+1
;       (D_EVEN):(D_EVEN)+1 MOD 2
;       Z:SOURCE END
GO1S2:
        LD      A,(D_EVEN)
        XOR     1
        LD      (D_EVEN),A
        RET     NZ      ;EVEN?
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        RET
;
; GO 1 STEP (SOURCE=8BIT PCM)
; ENTRY HL:SOURCE ADR.
; EXIT  HL:SOURCE ADR.+1
;       Z:SOURCE END
GO1S3:
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        RET
;
; GET STEP SIZE (16 BIT PCM)
; ENTRY (D_MODE)
; EXIT  BC:SIZE by STEP
GETSIZE:        ;2DATA/1BYTE
        LD      A,(D_MODE)
        OR      A
        JR      NZ,GETSIZE2
        LD      BC,(D_SIZ)
        RET
GETSIZE2:       ;1DATA/2BYTE
        DEC     A
        SRL     A
        JR      NZ,GETSIZE3
        LD      BC,(D_SIZ)
        SRL     B
        RR      C
        RET
GETSIZE3:
        LD      BC,(D_SIZ)
        RET
;
; ENTRY A:MODE
SWITCH:
        LD      B,A
        ADD     A,A
        ADD     A,A
        ADD     A,A
        ADD     A,A
        SUB     B
        LD      HL,SWBLOCK
        CALL    HLADDA
        LD      DE,CONV1SW1
        LD      BC,9
        LDIR
        LD      DE,CONV1SW2
        LD      BC,3
        LDIR
        RET
;
;       ADPCM to BRZ
SWBLOCK:
SWBLOCK10:
        CALL    CONV1L2
        CALL    CONV1C2
        CALL    CONV1C1
SWBLOCK20:
        CALL    GO1S2
;
;       16BIT PCM to BRZ
;       (SIGNED)
SWBLOCK11:
        CALL    CONV1L1
        CALL    CONV1C1
        NOP
        NOP
        NOP
SWBLOCK21:
        CALL    GO1S1           ;SOURCE
;
;       16BIT PCM to BRZ
;       (UNSIGNED)
SWBLOCK12:
        CALL    CONV1L15
        CALL    CONV1C1
        NOP
        NOP
        NOP
SWBLOCK22:
        CALL    GO1S1           ;SOURCE
;
;       8BIT SIGNED to BRZ
SWBLOCK13:
        CALL    CONV1L3
        CALL    CONV1C3
        NOP
        NOP
        NOP
SWBLOCK23:
        CALL    GO1S3           ;SOURCE
;
;       8BIT UNSIGNED to BRZ(NO OPERATION)
SWBLOCK14:
        CALL    CONV1L3
        LD      B,0
        INC     B               ;NZ
        NOP
        NOP
        NOP
SWBLOCK24:
        CALL    GO1S3           ;SOURCE
;
;       8BIT UNSIGNED(TOWNS) to BRZ
SWBLOCK15:
        CALL    CONV1L3
        CALL    CONV1C4
        NOP
        NOP
        NOP
SWBLOCK25:
        CALL    GO1S3           ;SOURCE
;
XX:     DW      0
YY:     DW      0
;
;
;
HEADER:
        LD      HL,MEMTOP       ;HEADER CLEAR
        LD      DE,MEMTOP+1
        LD      (HL),0
        LD      BC,HDRSIZE-1
        LDIR
;
        LD      DE,MEMTOP+HDR_NAM
        LD      HL,D_SNAME
        LD      BC,8
        LDIR
        LD      HL,(D_SIZ2)
        LD      (MEMTOP+HDR_SIZ),HL
        LD      HL,(D_FREQ2)
        LD      (MEMTOP+HDR_FRQ),HL
        RET
;
;
;
;
; INTERLACE CHECK
; ENTRY HL:COUNTER for INTERLACE
;       DE:DATA1(for SOURCE FREQ.)
;       BC:DATA2(for DESTINATION FREQ.)
; EXIT  NZ:DATA1 go 1STEP
;       NC:DATA2 go 1STEP
ILCHK:
        BIT     7,H
        JR      Z,ILCHK21       ;HL>=0 ?
        ADD     HL,BC
        XOR     A               ;NC,Z
        INC     A               ;NC,NZ
        SCF                     ;C,NZ
        RET
ILCHK21:
        OR      A
        SBC     HL,DE
        XOR     A               ;NC,Z
        RET
;
; ENTRY A:ADPCM DATA(4bits)
;       C:X(0..48)
; EXIT  HL:PCM DATA', C:X'(-1..56)
CNVADTOPW:
        PUSH    AF
        LD      A,C
        ADD     A,A
        LD      HL,TBLXTOD
        CALL    HLADDA
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        LD      L,E
        LD      H,D
        POP     AF
        BIT     3,A
        JR      Z,CNVADTOPW2
        AND     7               ;111B
        CALL    CNVADTOPW2
        JP      NEGHL

;
; CONVERTION ADPCM to 16BIT PCM
; ENTRY A:ADPCM DATA(3bits)
;       HL,DE:DATA D(X)
;       C:INDEX X
; EXIT  HL:FIX( D(X)*C(A)/8 )
;       C:INDEX X
CNVADTOPW2:
        PUSH    HL
        ADD     A,A
        LD      HL,JTBLAD1
        CALL    HLADDA
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        JP      (HL)
JTBLAD1:
        DW      CNVADTOPW20
        DW      CNVADTOPW21
        DW      CNVADTOPW22
        DW      CNVADTOPW23
        DW      CNVADTOPW24
        DW      CNVADTOPW25
        DW      CNVADTOPW26
        DW      CNVADTOPW27
;
CNVADTOPW20:
        POP     HL
        DEC     C
CNVADTOPW209:
;       HL/8
        SRL     H
        RR      L
        SRL     H
        RR      L
        SRL     H
        RR      L
        RET
CNVADTOPW21:
        POP     HL
        ADD     HL,HL
        ADD     HL,DE
        DEC     C
        JR      CNVADTOPW209
CNVADTOPW22:
        POP     HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        DEC     C
        JR      CNVADTOPW209
CNVADTOPW23:
        POP     HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        OR      A
        SBC     HL,DE
        DEC     C
        JR      CNVADTOPW209
CNVADTOPW24:
        POP     HL
        INC     C
        INC     C
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        JR      CNVADTOPW209
CNVADTOPW25:
        POP     HL
        INC     C
        INC     C
        INC     C
        INC     C
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        ADD     HL,DE
        ADD     HL,DE
        JR      CNVADTOPW209
CNVADTOPW26:
        POP     HL
        LD      A,6
        ADD     A,C
        LD      C,A
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        OR      A
        SBC     HL,DE
        SBC     HL,DE
        SBC     HL,DE
        JR      CNVADTOPW209
CNVADTOPW27:
        POP     HL
        LD      A,8
        ADD     A,C
        LD      C,A
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        OR      A
        SBC     HL,DE
        JR      CNVADTOPW209
;
TBLXTOD:
        DW      16,  17,  19,  21,  23,  25,  28,  31,  34,  37,  41,  45,  50
        DW      55,  60,  66,  73,  80,  88,  97, 107, 118, 130, 143, 157, 173
        DW      190,209, 230, 253, 279, 307, 337, 371, 408, 449, 494, 544, 598
        DW      658,724, 796, 875, 963,1060,1166,1282,1411,1552
;
; ENTRY C:X(-1..56)
; EXIT  C:X(0..48)
XCLIP:
        LD      A,C
        CP      255             ;'-1'
        JR      NZ,XCLIP2
        INC     C               ;255+1=0
        RET
XCLIP2:
        CP      49
        RET     C
        LD      C,48
        RET

;
; CONVERTION 16BIT PCM to 8 BIT
;            with CLIPPING
; ENTRY HL:PCM DATA(16bits) unsigned
;       A:EXPAND RATIO
;       DE:OFFSET( < 0 )
; EXIT  A:PCM DATA(8bits)
;       Z:CLPIPED OUT, NZ:NOT CLIPPED
CNVPWTOPH:
        PUSH    DE
        LD      D,0
        LD      E,A
        CALL    DIV16
        POP     DE
        ADD     HL,DE
        BIT     7,H
        JR      NZ,CNVPWTOPH921
        LD      A,H
        OR      A
        JR      NZ,CNVPWTOPH922
CNVPWTOPH91:
        XOR     A
        INC     A
        LD      A,L
        RET
CNVPWTOPH921:
        XOR     A
        RET
CNVPWTOPH922:
        XOR     A
        LD      A,255
        RET
;
;       CLEAR 'SMTBL'
;
CSMTBL:
        LD      HL,SMTBL
        LD      A,(D_SMN)
        LD      B,A
CSMTBL11:
        LD      (HL),$80
        INC     HL
        DJNZ    CSMTBL11
        RET
;
;       PUT DATA to 'SMTBL'
; ENTRY A:DATA, (D_SMP)
PUTSMTBL:
        PUSH    AF
        LD      HL,D_SMP
        LD      A,(HL)
        LD      DE,SMTBL
        CALL    DEADDA
        POP     AF
        LD      (DE),A
        INC     (HL)
        LD      A,(D_SMN)
        DEC     A               ;D_SMN>0!!
        CP      (HL)
        RET     NC              ;(D_SMN)>(D_SMP)?
        LD      (HL),0          ;POINTER RESET
        RET
;
;       GET DATA from 'SMTBL'
; EXIT  A:SMOOTHED DATA from 'SMTBL'
GETSMTBL:
        LD      HL,SMTBL
        LD      A,(D_SMN)
        CP      1
        JR      Z,GETSMTBL2     ;D_SMN=1?
        LD      B,A
        LD      DE,0            ;SUM
GETSMTBL11:
        LD      A,(HL)
        INC     HL
        CALL    DEADDA
        DJNZ    GETSMTBL11
        EX      DE,HL           ;SUM=HL
        LD      A,(D_SMN)
        CP      2
        JR      Z,GETSMTBL3     ;(D_SMN)=2?
        LD      E,A
        LD      D,0
        CALL    DIV16           ;SUM/(D_SMN)
        LD      A,L
        RET
GETSMTBL2:
        LD      A,(HL)
        RET
GETSMTBL3:
        SRL     H
        RR      L
        LD      A,L
        RET

;
;HPC File Loader
; PCM2BRZ VERSION
;
; EXIT  Z:BRKEY
;       C:ERROR
;
LOAD1:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "SOURCE FILE NAME?",$00
        CALL    INPUTS1
        LD      DE,BFFN1
        CALL    #MSX
        CALL    INPUTS2
        JP      Z,LOAD193       ;CANCEL
;
        CALL    SKPSP
        LD      A,(DE)
        CP      $00
        JR      Z,LOAD12
        LD      (BFDE1),DE
        CALL    SKPCL
        JP      C,LOAD129
        LD      (#DSK),A
        LD      A,(DE)
        CP      $00
        JR      Z,LOAD12
        LD      DE,(BFDE1)
        JR      LOAD129
;       INPUT NULL FILE
LOAD12:
        CALL    #DIR
        JR      NC,LOAD122
;       ERROR
        CALL    ERR
        CALL    #MPRNT
        DB      "CAN'T GET DIR",$0D,$00
        JP      LOAD192
LOAD122:
        CALL    KEYWAIT
        CALL    #CSR
        LD      (BFCSR1),HL
        CALL    #MPRNT
        DB      "=== HIT <CR> ON FILENAME. =============",$00
        LD      HL,(BFCSR1)
        CALL    #LOC
        LD      DE,(#KBFAD)
        CALL    #GETL
        PUSH    DE
        LD      HL,(BFCSR1)
        CALL    #LOC
        CALL    #LTNL
        POP     DE
        LD      A,(DE)
        CP      $1B
        JP      Z,LOAD1         ;CANCEL
        LD      A,5
        CALL    DEADDA          ;DUMMY
LOAD129:
        LD      (BFDE1),DE
;
        CALL    CUTFN
        LD      HL,(BFDE1)
        LD      DE,BFFN1
        CALL    TRSTR
        LD      HL,BFFN1
        LD      DE,BFFN2
        PUSH    HL
        CALL    DFLTFN2
        POP     HL              ;HL=BFFN1
        LD      DE,D_SNAME
        CALL    DFLTSN
LOAD15:
        LD      DE,BFFN1
        PUSH    DE
        LD      A,ATR_BIN
        LD      (BFATR),A
        CALL    #FILE
;       CALL    #FPRNT
        CALL    #ROPEN
        POP     DE
        JR      NC,LOAD16
        LD      A,ATR_ASC
        LD      (BFATR),A
        CALL    #FILE
;       CALL    #FPRNT
        CALL    #ROPEN
        CALL    C,ERR
        JR      C,LOAD192       ;ERROR
LOAD16:
;       FILE SIZE CHECK
        LD      HL,(MEMSIZE)
        LD      DE,(#SIZE)
        OR      A
        SBC     HL,DE
        JR      NC,LOAD169
        CALL    #MPRNT
        DB      "ERROR:FILE TOO BIG",$0D
        DB      " FILE SIZE:",$00
        LD      HL,(#SIZE)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES",$0D,$00
        LD      HL,(MEMSIZE)
        CALL    PRTDECI
        CALL    #MPRNT
        DB      "BYTES FREE",$0D,$00
        JR      LOAD192
LOAD169:
        LD      HL,(#MEMAX)
        LD      DE,(#SIZE)
        OR      A
        SBC     HL,DE
        LD      (MEMADR2),HL
        LD      (#DTADR),HL
;
;       FILE OPEN SUCCEED
LOAD191:
        XOR     A               ;Z,NC
        INC     A               ;NZ,NC
        RET
;
;       FILE OPEN FAILURE
LOAD192:
        CALL    #MPRNT
        DB      "FILE CAN'T OPEN",$0D,$00
        XOR     A
        INC     A               ;NZ,NC
        SCF
        RET
;
;       CANCEL
LOAD193:
        XOR     A               ;Z,NC
        RET
;
;
;EXIT   C:ERROR
;
LOAD2:
;       FILE READ
        CALL    #RDD
        CALL    C,ERR
        JR      C,LOAD292
;
;       NO ERROR
        LD      HL,(#SIZE)
        LD      (FSIZE1),HL
        XOR     A
        INC     A               ;NZ,NC
        RET
;       ERROR
LOAD292:
        SCF                     ;CY
        RET
;
;
;HPC File Saver
;
; EXIT  Z:BRKEY
;
SAVE1:
        CALL    #MPRNT
        DB      "*",$0D
        DB      "DESTINATION FILE NAME?",$00
        CALL    INPUTS1
        LD      DE,BFFN2
        CALL    #MSX
        CALL    INPUTS2
        RET     Z               ;CANCEL
;
        EX      DE,HL           ;HL=(#KBFAD)
        LD      DE,BFFN2
        LD      (BFDE2),DE
        CALL    TRSTR
        XOR     A
        INC     A
        RET                     ;NZ
;
;
;EXIT   C:ERROR
;
SAVE2:
        LD      DE,(BFDE2)
        PUSH    DE
        LD      A,ATR_BIN
        CALL    #FILE
        CALL    #ROPEN
        POP     DE
        JR      NC,SAVE21
        LD      A,ATR_ASC
        CALL    #FILE
        CALL    #ROPEN
        JR      C,SAVE22
;       ALREADY EXIST
SAVE21:
        CALL    #MPRNT
        DB      "WARNING!:FILE ALREADY EXIST",$0D,$00
;       FILE OPEN & WRITE
SAVE22:
        LD      HL,(FSIZE2)
        LD      (#SIZE),HL
        LD      HL,DATATOP      ;on FILE
        LD      (#DTADR),HL
        LD      HL,#HOT
        LD      (#EXADR),HL
;
        LD      A,(BFATR)
        LD      DE,(BFDE2)
        CALL    #FILE
;       CALL    #FPRNT
        CALL    #WOPEN
        CALL    C,ERR
        JR      C,SAVE292       ;ERROR
;       FILE OPEN SUCCEED
;       FILE WRITE
        LD      HL,MEMTOP       ;on MEMORY
        LD      (#DTADR),HL
        CALL    #WRD
        CALL    C,ERR
        JR      C,SAVE292       ;ERROR
;
;       NO ERROR
SAVE291:
        XOR     A               ;NC
        RET
;       ERROR
SAVE292:
        CALL    #MPRNT
        DB      "FILE CAN'T WRITE",$0D,$00
        SCF                     ;CY
        RET
;
;       CUT FILE NAME
;       ENTRY   DE:STR.ADR
CUTFN:
        PUSH    DE
        PUSH    DE
        CALL    SKPSP
        EX      DE,HL           ;LD HL,DE
        POP     DE
CUTFN105:
        LD      A,(HL)
        LD      (DE),A
        INC     HL
        INC     DE
        OR      A
        JR      NZ,CUTFN105
        POP     DE              ;LD DE,HL
;
        INC     DE
        LD      A,(DE)
        CP      ":"
        JR      Z,CUTFN11
        DEC     DE
        DEC     DE
CUTFN11:
        INC     DE
        CALL    SKPCL
        JR      C,CUTFN12
        DEC     DE
        XOR     A
        LD      (DE),A          ;END CODE
CUTFN12:
        RET
;
;       SKIP SPC
;       ENTRY   DE:STR. ADR
;       EXIT    DE:STR. ADR
SKPSP:
        LD      A,(DE)
        CP      $20             ;SPC. CODE
        RET     NZ
        INC     DE
        JR      SKPSP
;
; SKIP into COLON
; ENTRY DE:STR. ADR
; EXIT  DE:STR. ADR
;       CY:NO COLON
SKPCL:
        PUSH    BC
        PUSH    DE
        LD      B,0
SKPCL11:
        LD      A,(DE)
        CP      ":"
        JR      Z,SKPCL91
        OR      A
        JR      Z,SKPCL92
        LD      B,A
        INC     DE
        JR      SKPCL11
SKPCL91:
        LD      A,B
        INC     DE
        OR      A
        POP     BC              ;DUMMY
        JR      SKPCL99
SKPCL92:
        XOR     A               ;LD A,0
        SCF                     ;NO COLON
        POP     DE
SKPCL99:
        POP     BC
        RET
;
; ENTRY HL:KBFAD,DE:BFFN
;               ($00:END)
TRSTR:
        LD      B,32            ;MAX LENGTH
TRSTR11:
        LD      A,(HL)
        LD      (DE),A
        INC     HL
        INC     DE
        OR      A
        RET     Z
        DJNZ    TRSTR11
        RET
;
; ENTRY HL:BFFN1
;       DE:BFFN2
DFLTFN2:
        EX      DE,HL
        CALL    SKPDV
        CALL    TRSFN2
        EX      DE,HL
        LD      HL,EXPSTR
        LD      BC,5
        LDIR
        RET
;
; TRANS FILE NAME (DE-) to (HL-) only PRIMARY
; ENTRY DE:STR.ADR.
; EXIT  HL:PRIMARY NAME(LENGTH_PRIMARY)
TRSFN2:
        LD      B,(LENGTH_PRIMARY)
        LD      B,A
TRSFN21:
        LD      A,(DE)
        CP      "."
        JR      Z,TRSFN22
        CP      $00
        JR      Z,TRSFN22
        LD      (HL),A
        INC     DE
        INC     HL
        DJNZ    TRSFN21
        JR      TRSFN29
TRSFN22:
        LD      (HL),$20
        INC     HL
        DJNZ    TRSFN21
TRSFN29:
        RET
;
EXPSTR: DB      ".BRZ",$00
;
; ENTRY HL:BFFN1
;       DE:D_SNAME
DFLTSN:
        EX      DE,HL
        CALL    SKPDV
        LD      B,8
        JR      TRSFN21
;
; ENTRY DE:STR.ADR.
; EXIT  DE:STR.ADR.(NEXT by CORON)
SKPDV:
        INC     DE
        LD      A,(DE)
        DEC     DE
        CP      ":"             ;CORON
        JR      NZ,SKPDV12
        INC     DE
        INC     DE
SKPDV12:
        RET
;
; ENTRY DE:DATA1, A:DATA2(>0)
; EXIT  DE:DATA1+DATA2
DEADDA:
        ADD     A,E
        LD      E,A
        LD      A,D
        ADC     A,0
        LD      D,A
        RET
;
;
ERR:
        PUSH    AF
        CALL    #MPRNT
        DB      "ERROR:",$00
        POP     AF
        RET
;
;
KEYWAIT:
        CALL    #GETKY
        OR      A
        JR      NZ,KEYWAIT
        RET
;
;       EXIT    A:KEYCODE
;               Z:BRKEY
GET1CHR:CALL    #GETKY
        OR      A
        JR      NZ,GET1CHR
        CALL    #INKEY
        CP      $20
        JR      C,GET1CHR91
        PUSH    AF
        CALL    #PRINT
        POP     AF
GET1CHR91:
        CP      $03     ;BRKEY=Z
        RET             ;NZ
;
;       DS      128
;USRSTK:
;
CODE_END:
MEMTOP:
;
;[EOF]
